/* NessusJ
 * Copyright (C) 1998 Alexis de Bernis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This class encapsulates a plugin. It's also a component.
 *
 *  Please run class NessusJ instead.
 */


import java.lang.*;
import java.awt.*;
import com.sun.java.swing.*;
import java.awt.event.*;
import com.sun.java.swing.border.*;



class PlugIn extends JPanel implements ActionListener
{
    private int id;
    private String name;
    private String copyright;
    private String description;
    private String summary;
    private String type;
    private String family;
    private JCheckBox state;
    private Preferences prefs;
    private JButton nameToClick;

    PlugIn(int id,String name,String copyright,String description,
           String summary,String type,String family,boolean actived,
           Preferences prefs)
    {
        super();

        this.id=id;
        this.name=name;
        this.copyright=copyright;
        this.description=description;
        this.summary=summary;
        this.type=type;
        this.family=family;
        this.prefs=prefs;

        setLayout(new BorderLayout());
        state=new JCheckBox("",actived);
        state.addActionListener(this);
        state.setActionCommand("state");
        state.setIcon(new ImageIcon("l_red.gif"));
        state.setSelectedIcon(new ImageIcon("l_green.gif"));
        nameToClick=new JButton(name);
        nameToClick.setBorder(new EmptyBorder(0,0,0,0));
        nameToClick.setToolTipText(summary);
        nameToClick.addActionListener(this);

        add("West",nameToClick);
        add("East",state);
        setBorder(new EtchedBorder());

    }

    public boolean isActivated()
    {
        return(state.isSelected());
    }

    public void setActivated(boolean temp)
    {
        state.setSelected(temp);
        prefs.setPluginActivated(name,state.isSelected());
    }


    public int getId()
    {
        return(id);
    }

    public String getName()
    {
        return(name);
    }

    public String getCopyright()
    {
        return(copyright);
    }

    public String getDescription()
    {
        return(description);
    }

    public String getSummary()
    {
        return(summary);
    }

    public String getType()
    {
        return(type);
    }

    public String getFamily()
    {
        return(family);
    }

    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("state"))
            prefs.setPluginActivated(name,state.isSelected());
            
        if(command.equals(name))
            new PluginProperties((JFrame) getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent(),this);

    }


}

