/* NessusJ
 * Copyright (C) 1998 Alexis de Bernis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This display a window to choose plugins.
 *
 *  Please run class NessusJ instead.
 */


import java.lang.*;
import java.awt.*;
import java.util.*;
import com.sun.java.swing.*;
import java.awt.event.*;
import com.sun.java.swing.border.*;


class PluginList extends JFrame implements WindowListener,ActionListener
{
    JScrollPane pane,familyPane;
    JPanel fields;
    Box list,listFamily;
    JButton close;
    Vector plugins;
    NessusdLauncher parent;
    JPanel button;
    Hashtable families;

    PluginList(NessusdLauncher parent,Vector plugins, Hashtable families)
    {
        super("Plugin list");

        this.plugins=plugins;
        this.parent=parent;
        this.families=families;

        getContentPane().setLayout(new BorderLayout());
        list=new Box(BoxLayout.Y_AXIS);
        listFamily=new Box(BoxLayout.Y_AXIS);
        pane=new JScrollPane(list);
        pane.setBorder(new TitledBorder(new EtchedBorder(),
                                        "Plugins:",
                                        TitledBorder.DEFAULT_JUSTIFICATION,
                                        TitledBorder.DEFAULT_POSITION));
        familyPane=new JScrollPane(listFamily);
        familyPane.setBorder(new TitledBorder(new EtchedBorder(),
                                              "Families:",
                                               TitledBorder.DEFAULT_JUSTIFICATION,
                                               TitledBorder.DEFAULT_POSITION));

        int size=families.size();
        if(size<4)
            size=4;

        fields=new JPanel(new GridLayout(0,1));
        close=new JButton("Close");
        close.addActionListener(this);
        button=new JPanel(new FlowLayout());
        fields.add(familyPane);
        fields.add(pane);
        button.add(close);

        getContentPane().add("North",new JLabel("Choose plugins to be tested :"));
        getContentPane().add("Center",fields);
        getContentPane().add("South",button);

//        for(int i=0;i<plugins.size();i++)
//            list.add( (PlugIn) plugins.elementAt(i));

        list.add(Box.createGlue());

        Enumeration temp=families.elements();
        while(temp.hasMoreElements())
            listFamily.add((Family) temp.nextElement());


        setSize(453,511);
        setResizable(true);
        setVisible(true);
    }


    private void clearText(TextArea area)
    {
        area.setText("");
    }

    public void refreshList(Family toRefresh)
    {
        list.removeAll();
        Enumeration children=toRefresh.getChildren().elements();

        while(children.hasMoreElements())
            list.add((PlugIn) children.nextElement());


    validateTree();

    }

    public void windowClosing(WindowEvent evt)
    {
        dispose();
        parent.show();
    }


    public void windowClosed(WindowEvent evt ) { }
    public void windowOpened(WindowEvent evt) { }
    public void windowOpening(WindowEvent evt ) { }
    public void windowIconified(WindowEvent evt ) { }
    public void windowActivated(WindowEvent evt ) { }
    public void windowDeiconified(WindowEvent evt ) { }
    public void windowDeactivated(WindowEvent evt ) { }


    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("Close"))
        {
            dispose();
            parent.show();
        }
    }

}
