/* NessusJ
 * Copyright (C) 1998 Alexis de Bernis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This class display the plugin property box
 *
 *  Please run class NessusJ instead.
 */


import java.lang.*;
import java.awt.*;
import java.util.Vector;
import com.sun.java.swing.*;
import java.awt.event.*;


class PluginProperties extends JDialog implements ActionListener
{
    JPanel header,top,text;
    JButton close;
    JTextArea description;
    JLabel icon;
    PlugIn plugin;

    PluginProperties(JFrame parent, PlugIn plugin)
    {
        super(parent,"Plugin properties",true);

        if(plugin.getType().equals("denial"))
            icon=new JLabel(new ImageIcon("bomb.gif"));

        if(plugin.getType().equals("infos"))
            icon=new JLabel(new ImageIcon("info.gif"));

        if(plugin.getType().equals("attack"))
            icon=new JLabel(new ImageIcon("attack.gif"));

        this.plugin=plugin;

        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        header=new JPanel(new BorderLayout());
        top=new JPanel(new BorderLayout());
        close=new JButton("Close");
        close.addActionListener(this);
        description=new JTextArea(10,20);
        description.setLineWrap(true);
        description.setWrapStyleWord(true);
        text=new JPanel(new GridLayout(2,0));

        text.add(new JLabel(plugin.getName(),JLabel.CENTER));
        text.add(new JLabel(plugin.getCopyright(),JLabel.CENTER));

        top.add("Center",text);
        top.add("South",new HRule(350,1,0,1));
        top.add("West",icon);

        header.add("Center",top);
        header.add("South",new JLabel("Family : "+plugin.getFamily()));

        getContentPane().add("North",header);
        getContentPane().add("Center",description);
        getContentPane().add("South",close);

        description.append(plugin.getDescription());

        pack();
        setVisible(true);

    }

    
    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("Close"))
            dispose();
    }


}
